stages:
    - build
    - test

image: ubuntu:22.10

before_script:
    - apt update
    - apt -y install pkgconf gcc git qtbase5-dev qtbase5-private-dev meson ninja-build qtbase5-dev-tools cmake libqt5svg5-dev libwayland-dev qtwayland5-private-dev

build_amd64:
    stage: build
    script:
      - git clone https://gitlab.com/desktop-frameworks/wayqt
      - cd wayqt;
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j $(nproc) -k 0 && ninja -C .build install
      - cd ../
      - git clone https://gitlab.com/desktop-frameworks/utils
      - cd utils;
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j $(nproc) -k 0 && ninja -C .build install
      - cd ../
      - git clone https://gitlab.com/desktop-frameworks/settings
      - cd settings
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j $(nproc) -k 0 && ninja -C .build install
      - cd ../
      - git clone https://gitlab.com/desktop-frameworks/layouts
      - cd layouts
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j $(nproc) -k 0 && ninja -C .build install
      - cd ../
      - git clone https://gitlab.com/DesQ/libdesq
      - cd libdesq;
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j 4 -k 0 && ninja -C .build install
      - cd ../
      - git clone https://gitlab.com/DesQ/libdesqui
      - cd libdesqui;
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j 4 -k 0 && ninja -C .build install
      - cd ../
      - meson .build --prefix=/usr --buildtype=release
      - ninja -C .build -j $(nproc) -k 0 && ninja -C .build install

uncrustify:
    stage: test
    script:
        # Install all necessary packages
        - apt update && apt -y install git gcc g++ python3 cmake
        # Get out Meta repo
        - git clone https://gitlab.com/DesQ/Meta
        # Build Uncrustify
        - cd Meta/Uncrustify; mkdir .build && cd .build
        - cmake .. && make -kj$(nproc) && make install
        # Cleanup
        - cd ../../.. && cp Meta/uncrustify.cfg . && rm -rf Meta
        # Perform check
        - git ls-files | /bin/grep "\.hpp\$\|\.h\$\|\.cpp\$" | xargs uncrustify -c uncrustify.cfg --no-backup --replace
        - git diff
